// Project Sword & Gun Copyright Kevin Poretti

#pragma once

// FF includes
#include "State/IFFStateOwnerInterface.h"
#include "Input/FFInputBufferComponent.h"

// UE includes
#include "CoreMinimal.h"
#include "AIController.h"

#include "FFAIController.generated.h"

/**
 * 
 */
UCLASS()
class UNREALFIGHTINGFRAMEWORK_API AFFAIController : public AAIController, public IFFStateOwnerInterface
{
	GENERATED_BODY()

public:
    AFFAIController();

    // IFFStateOwnerInterface
    UFUNCTION(BlueprintCallable, Category="UFF State Owner Interface")
    virtual bool CheckInputSequence(const FFFInputSequence& InInputSequence) override;

    UFUNCTION(BlueprintCallable, Category="UFF State Owner Interface")
    virtual bool CheckInputSequences(const TArray<FFFInputSequence>& InInputSequences) override;

    virtual FVector GetInputAsWorldDirection() const override;

    virtual void DisableMostRecentInput() override;
    // End of IFFStateOwnerInterface

protected:
	/** Input Buffer component */
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "UFF|Input", meta = (AllowPrivateAccess = "true"))
	UFFInputBufferComponent* InputBuffer;
};
